/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32v30x_it.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main Interrupt Service Routines.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v30x_it.h"
#include "debug.h"
void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
  while (1)
  {
  }
}

void USART1_IRQHandler(void)
{
	int k, temp;
	if(USART_GetITStatus(USART1,USART_IT_IDLE) == SET)
	{
	    temp = USART1->STATR;
	    temp = USART1->DATAR; //USART_IT_IDLE־
		temp = usart_max - DMA_GetCurrDataCounter(DMA1_Channel5); //õݸ
		for (k = 0; k < temp; k++)
		{
			usart1_rxbuf[k] =  usart1_rx[k];
			usart1_rx[k] = 0;
		}
		printf("count=%d data=%s\n",temp,usart1_rxbuf);
		DMA_Cmd(DMA1_Channel5,DISABLE); //رDMA
		DMA1_Channel5->CNTR= usart_max;//ýݸ
		DMA_Cmd(DMA1_Channel5,ENABLE);  //DMA
		G_usart1_Rsign=1;
	}
	
 }

void USART_COM_DataReceiver(uint8_t *RxData)
{
    int temp1 = 0;
	if ((RxData[0] == 'G') && (RxData[1] == 'P') && (RxData[2] == 'S'))
	{
		temp1 = RxData[3] - 48;
		if ((temp1 >= 0) && (temp1 < 16))
		{
			G_prn_flag = temp1;
			printf(";GPS PRN SIGN%d\n", G_prn_flag);
		}
		else
		{
			G_prn_flag = 0;
			printf(";GPS PRN SIGN DEFAULT 0\n");
		}
	}	
}
